# FreePBX Manager

[![License](https://img.shields.io/badge/license-GPL--3.0-blue)](https://github.com/ChrisChrome/discord-freepbx-manager/blob/main/LICENSE)

## Description
FreePBX Manager is a Discord bot designed to manage FreePBX configurations. Please note that this project is currently a hot mess and may not be suitable for production use.

## Pre-requisites
- [Node.js](https://nodejs.org/en/download/)
- [FreePBX](https://www.freepbx.org/)
- [A Discord Bot](https://discord.com/developers/applications)

## Features
- [x] User-created extensions
- [x] Automatic extension creation
- [x] Extension deletion
- [x] Extension status
- [x] Extension list

- Probably some more stuff that I forgot to write down lol

## Setup
To set up the config file, follow the steps below:

1. Clone the repository:
   ```shell
   git clone https://git.chrischro.me/ChrisChrome/discord-freepbx-manager.git

   cd discord-freepbx-manager
   ```
2. Install the required dependencies:
   ```shell
   npm install --save
   ```

3. Copy `.env.example` to `.env`

4. Configure the `.env` file with the following options:

PBX_HOSTNAME: This is the hostname or IP address of your PBX (Private Branch Exchange) server. It is used to connect to the PBX system. This value is whats sent to the end users via the bot. Can be whatever and won't affect the functionality of the bot.

FREEPBX_URL: Base URL for the API of your PBX. i.e. `https://pbx.example.com`

FREEPBX_CLIENT_ID: This is the client ID used for authenticating with the FreePBX API. It is part of the OAuth2 authentication process.

FREEPBX_CLIENT_SECRET: This is the client secret used along with the client ID for authenticating with the FreePBX API.

DB_HOST: This is the hostname or IP address of your database server. It is used to connect to the database. If running on your PBX, set to `127.0.0.1`

DB_USER: This is the username used to authenticate with the database.

DB_PASS: This is the password used to authenticate with the database.

DISCORD_TOKEN: This is the token for your Discord bot. It is used to authenticate the bot with the Discord API.

OWNER_ID: This is the Discord user ID of the bot owner. It can be used to grant special permissions or access to the bot owner.

EXTENSION_ROLE_ID: Discord role ID of the role to give PBX users when they make their extension.

DISCORD_GUILD: This is the Discord server (guild) ID where the bot will operate. This is used to determine if extensions are orphaned, so make sure it's set correctly.

These environment variables are used to configure your application and provide necessary credentials and settings for connecting to various services. Make sure to keep this information secure and do not share it publicly.

5. Run the bot:
   ```shell
   node .
   ```
6. Invite the bot to your Discord server using the following link:
   ```
   https://discord.com/oauth2/authorize?client_id=YOUR_BOT_ID&scope=bot&permissions=8
   ```
7. You're all set! The bot should now be up and running.